/*
 *	Power Controller ver.2.00 arm9's source
 */

//----------------------------------------------------------------------------

#include	<nds.h>
#include	<stdio.h>
#include	"powerctl9.h"
#include	"thfifo.h"

static thfifo_t	pow_ch;

//-----------------------------------------------------------------------------
// Power on
//-----------------------------------------------------------------------------

void
power9on(u32 dev)
{
	if (dev & POW_ARM7) {
		fifoSendChan24(pow_ch, (POWCMD_ON | (dev & POW_ARM7)));
	}
	if (dev & POW_ENGINE_A) {
		powerON(POWER_2D_A);
	}
	if (dev & POW_ENGINE_B) {
		powerON(POWER_2D_B);
	}
	if (dev & POW_MATRIX) {
		powerON(POWER_MATRIX);
	}
	if (dev & POW_3D_CORE) {
		powerON(POWER_3D_CORE);
	}
}

//-----------------------------------------------------------------------------
// Power off
//-----------------------------------------------------------------------------

void
power9off(u32 dev)
{
	if (dev & POW_ARM7) {
		fifoSendChan24(pow_ch, (POWCMD_OFF | (dev & POW_ARM7)));
	}
	if (dev & POW_ENGINE_A) {
		powerOFF(POWER_2D_A);
	}
	if (dev & POW_ENGINE_B) {
		powerOFF(POWER_2D_B);
	}
	if (dev & POW_MATRIX) {
		powerOFF(POWER_MATRIX);
	}
	if (dev & POW_3D_CORE) {
		powerOFF(POWER_3D_CORE);
	}
}

//-----------------------------------------------------------------------------
// Get battery status
//-----------------------------------------------------------------------------

int
power9status(void)
{
	// Not implemented yet
	return	POW_GOOD;		// Dummy
}

//-----------------------------------------------------------------------------
// NDS Sleep Mode
//-----------------------------------------------------------------------------

void
power9sleep(void)
{
	fifoSendChan24(pow_ch, POWCMD_SLEEP);
}

//-----------------------------------------------------------------------------

void
power9ipc(thfifo_t ch, u32 data, void *swr)
{
    // Not implement yet
}

//-----------------------------------------------------------------------------
// Initialize Power Controller
//-----------------------------------------------------------------------------

void
power9init(void)
{
	pow_ch  = fifoChanCreate(POWIPC_NAME, NULL);

	fifoChanSetFunc(pow_ch, power9ipc);
	while (fifoChanRecvChk(pow_ch) != true);   // Wait for ARM7's setup
}

