
#ifndef	__POWERCTL9_H__
#define	__POWERCTL9_H__

#include	<nds.h>

//-[ Configurable parameter ]-------------------------------------------------


//-[ Global variables ]-------------------------------------------------------


//-[ Track variables ]--------------------------------------------------------


//-[ ARM9->ARM7 IPC protocol -------------------------------------------------

#define	POWIPC_NAME		"POWERCTL"				// POWER CONTROL PROTOCOL

#define	POWCMD_MASK		0xFF0000
#define	POWCMD_ON		0x010000				// Power On
#define	POWCMD_OFF		0x020000				// Power Off
#define	POWCMD_SLEEP	0x800000				// NDS Sleep Mode

#define	POW_MASK		0x00FFFF
#define	POW_LCD1		0x000001				// Upper LCD Backlight
#define	POW_LCD2		0x000002				// Lower LCD Backlight
#define	POW_ENGINE_A	0x000004				// 2D-Engine A
#define	POW_ENGINE_B	0x000008				// 2D-Engine B
#define	POW_MATRIX		0x000010				// 3D Rendering Engine
#define	POW_3D_CORE		0x000020				// 3D Geometry Engine
#define	POW_SPEAKER		0x000040				// Internal Speaker
#define	POW_SOUND_AMP	0x000080				// Sound Amplifer

#define	POW_ARM7	(POW_LCD1 | POW_LCD2 | POW_SPEAKER | POW_SOUND_AMP)
#define	POW_ARM9	(POW_ENGINE_A | POW_ENGINE_B | POW_MATRIX | POW_3D_CORE)


//-[ Function prototype ]-----------------------------------------------------

void	power9init(void);		// Power Controller initializer
void	power9on(u32);			// Power on
void	power9off(u32);			// Power off
int		power9status(void);		// Get battery status
void	power9sleep(void);		// Enter NDS Sleep Mode

#define	POW_OK				0	// OK
#define	POW_ERROR			1	// Error

#define	POW_GOOD			0	// Battery status is Good (Green)
#define	POW_LOW				1	// Battery status is Low  (Red)

//----------------------------------------------------------------------------

#endif	/* __POWERCTL9_H__ */


